Unit sf41e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF13_p;

procedure sf41e(N :Integer; K :Integer; P :Extended; var PK :Extended;
                var PS :Extended; var IERR :Integer);

implementation

procedure sf41e(N :Integer; K :Integer; P :Extended; var PK :Extended;
                var PS :Extended; var IERR :Integer);
var
K1,J,ICNT :Integer;
P1,Q1,XX,ALQN,QP,XJ,XN :Extended;
const
SYS055 :Real = 2.225074e-308;
SYS059 :Real = 1.7E308;
SYS077 :Real = -7.083964e+2;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
PK := 0.e0;
PS := 0.e0;
if ( K <= N ) and ( K >= 0 ) 
 then goto _1;
IERR := 65;
goto _9;
_1:
if ( P <= 1.e0 ) and ( P >= 0.e0 ) 
 then goto _2;
IERR := 66;
goto _9;
_2:
if ( P <> 0.e0 ) 
 then goto _3;
PS := 1.e0;
if ( K <> 0 ) 
 then goto _10;
PK := 1.e0;
goto _10;
_3:
if ( P <> 1.e0 ) 
 then goto _4;
if ( K <> N ) 
 then goto _10;
PK := 1.e0;
PS := 1.e0;
goto _10;
_4:
P1 := P;
Q1 := 1.e0-P;
K1 := K;
XN := N;
XX := XN*P;
if ( K <= XX ) 
 then goto _5;
P1 := Q1;
Q1 := P;
K1 := N-K;
_5:
ALQN := XN*Ln(Q1);
ICNT := Trunc( ALQN/SYS077 );
ALQN := ALQN-ICNT*SYS077;
PK := Exp(ALQN);
if ( K1 = 0 ) 
 then goto _7;
QP := P1/Q1;
XJ := 0.e0;
XN := XN+1.e0;
for J:=1 to K1 do
 begin
  if ( ICNT = 0 ) 
   then PS := PS+PK;
  XJ := XJ+1.e0;
  PK := PK*(QP*(XN-XJ));
  if ( PK < XJ ) 
   then goto _6;
  PK := PK*SYS055;
  ICNT := ICNT-1;
_6:
  PK := PK/XJ;
 end;
_7:
if ( ICNT <> 0 ) 
 then PK := 0.e0;
if ( K > XX ) 
 then goto _8;
PS := PS+PK;
goto _10;
_8:
PS := 1.e0-PS;
goto _10;
_9:
UTSF13(IERR,41);
PK := SYS059;
PS := SYS059;
_10:
end;

end.
